#!/usr/bin/python
# Umap v0.8 (UPNP Map)
# formatez@toor.do (Daniel Garcia)
# http://www.toor.do/
#
# UPNP NAT Hole puncher/Scanner
# --------------------------------
# This program attempts to 
# 1) Scan open TCP ports on the hosts behind a UPNP enabled Internet Gateway Device(IGD) NAT
# 2) Execute UPnP actions on hosts
# 3) Scan for UPnP devices with SSDP and description file scanning
#
#
# For more information on the subject:
# http://www.upnp-hacks.org/
# http://www.gnucitizen.org/
# http://www.sourcesec.com/2008/11/07/miranda-upnp-administration-tool/
#
# 
#
# Code docs/comments coming soon.


#import sys
import os
import socket, SocketServer
import urllib2
import getopt
import xml.dom.minidom as minidom
import threading
import Queue
import random
import time
import uscan, usocks, upnpscan, uctui, utui
import curses
from SOAPpy import *


# Default ports scanned for LAN hosts
commonPorts = ['21','22','23','80','137','138','139','443','445','3389', '8080']

# Uscan queue
queue = Queue.Queue()

# IP List
upnpList = []

# Service List
serviceList = {}

# Mappings list
mapList = []

threadList = []

def main(wrappedScr):

    mapDict = {}
    
    killIt = 0
    
    if not cursesMode:
	if ipArg:
		tui = utui.uTUI(ipArg, queue, upnpList, verbose, serviceList, portList)
	else:
		tui = utui.uTUI('', queue, upnpList, verbose, serviceList, portList)
	tui.cmdloop()
	sys.exit()
  
    if ipArg and not socks and cursesMode:
        scr = uctui.uCTUI(0, selectedIP, selectedIPXML, upnpList, serviceList, mapList, wrappedScr)
        scr.mainScreen.nodelay(1)
        scr.printMessage("Trying "+ipArg)
        scr.draw()
	upnpScan = upnpscan.UPNPScan(ipArg, upnpList, scr, selectedIPXML, serviceList, verbose)
	upnpScan.setDaemon(True)
	upnpScan.start()
	upnpScan.join()

        if len(upnpList) == 0:
            scr.printMessage("[E] Couldn't find a match")
	else:
	    splitUPnP = upnpList[0].split('|')
	    location = splitUPnP[3]+"|"+splitUPnP[4]+"|"+splitUPnP[5]
	    scanned = upnpScan.getInfo(location, ipArg, 1)
	    
	    
	    
	    if splitUPnP[9] != '':
	    	
                guessIP(splitUPnP[9], cursesMode, scr)
	    else:
	    	
	        guessIP('', cursesMode, scr)

    	try:

        	while True:
            	    if(threading.activeCount() < max_threads):
                        current_ip = queue.get()
	                umap = uscan.Uscan(ipArg, current_ip, scanned, queue, verbose, portList, mapList, scr)
                	umap.setDaemon(True)
	                umap.start()
                    if umap.stopIt.isSet():
                    		break
			
		    time.sleep(0.2)
                    scr.draw()
		    input = scr.mainScreen.getch()
		    if input == ord('q'): 
		        scr.exitCurse()
		        sys.exit()



    	except KeyboardInterrupt:
          	scr.printMEssage("Caught interrupt! waiting for threads and exiting")
		scr.exitCurse()
        	umap.stopIt.set()
        	umap.join()

    if socks and (file or ipArg) and cursesMode:
        scr = uctui.uCTUI(1, selectedIP, selectedIPXML, upnpList, serviceList, mapList, wrappedScr)
	if file:
		ipListfh = open(file, 'r')
		ipList = ipListfh.readlines()
		for line in ipList:
			c = 1
			if line.find('#') != -1: continue
			splitIP = line.split('.')
			if len(splitIP) == 4:
				while c < 255:
					lineIP = str(splitIP[0])+"."+str(splitIP[1])+"."+str(splitIP[2])+"."+str(c)
					if c == 1:
						scr.printMessage("[-] Adding block: "+lineIP)
					queue.put(lineIP)
					c += 1
			else:
				scr.printMessage("[E]Error in format!")

	if ipArg:
		if '*' in ipArg:
			c = 1
			while c < 255:
				splitIP = ipArg.split('.')
				lineIP = str(splitIP[0])+"."+str(splitIP[1])+"."+str(splitIP[2])+"."+str(c)
				if c == 1:
					scr.printMessage("[-] Adding block: "+lineIP)
				queue.put(lineIP)
				c += 1
		scr.printMessage("Adding: "+ipArg)
		queue.put(ipArg)

	try:
		socksServer = usocks.UsocksServer(('', 1080), usocks.UsocksHandle)
	except:
		curses.endwin()
		print("Couldn't bind to port")
		sys.exit(0)
	socksServer.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
	socksThread = threading.Thread(target=socksServer.serve_forever)
	socksThread.setDaemon(True)
	socksThread.start()

				
	totalCount = 0
	try:


		while True:

			if not queue.empty():
				current_ip = queue.get()
	                       	upnpScan = upnpscan.UPNPScan(current_ip, upnpList, scr, selectedIPXML, serviceList, verbose)

			if cursesMode:
				scr.mainScreen.nodelay(1)
				time.sleep(0.2)
				scr.draw()
	                        input = scr.mainScreen.getch()
				lenUPnP = len(upnpList)
				scan = ()
				if lenUPnP > 0 and selectedIP < lenUPnP and len(scr.selectedIPXML) == 0:
					splitUPnP = upnpList[scr.selectedIP].split('|')
					location = splitUPnP[3]+"|"+splitUPnP[4]+"|"+splitUPnP[5]
					scan = upnpScan.getInfo(location, upnpList[scr.selectedIP].split('|')[0], 1)

	                        if input == ord('q'):
					socksServer.shutdown() 
					socksThread.join()
					killIt = 1
					scr.exitCurse()
					sys.exit()
					
					
				if input == ord('r'): 
					scr.mainScreen.refresh()
				if input == ord('e'):
					if lenUPnP == 0:
						scr.printMessage("No positive matches")
						return False
					scr.mainScreen.nodelay(0)
					scr.drawExecute()
					scr.mainScreen.nodelay(1)
				if (input == ord('u') or input == curses.KEY_UP) and selectedIP >= 0:
	                                scr.cursorUp()
					splitUPnP = upnpList[scr.selectedIP].split('|')
					location = splitUPnP[3]+"|"+splitUPnP[4]+"|"+splitUPnP[5]
					scr.selectedIPXML = {}
					mapDict = {}
				if (input == ord('d') or input == curses.KEY_DOWN) and selectedIP < lenUPnP: 
	                                scr.cursorDown()
					splitUPnP = upnpList[scr.selectedIP].split('|')
					location = splitUPnP[3]+"|"+splitUPnP[4]+"|"+splitUPnP[5]
					scr.selectedIPXML = {}
					mapDict = {}
			else:
				splitUPnP = upnpList[0].split('|')
                                location = splitUPnP[3]+"|"+splitUPnP[4]+"|"+splitUPnP[5]
                                scan = upnpScan.getInfo(location, upnpList[0].split('|')[0], 1)

		     
			socksServer.scan = scan
			socksServer.IPlist = upnpList
			socksServer.map = mapDict
			socksServer.scr = scr
			socksServer.selectedIP = selectedIP



			if(threading.activeCount() < int(max_threads)):
				totalCount += 1
				if queue.empty() and current_ip == 0:
					continue
				else:
					scr.printMessage("Scanning("+str(threading.activeCount())+","+str(totalCount)+"): "+current_ip)
					upnpScan.setDaemon(True)
					upnpScan.start()
					threadList.append(upnpScan)
					current_ip = 0
			else:
				for t in threadList:
					t.join()
					
			if killIt == 1:
				sys.exit()
				break				
				


	except KeyboardInterrupt:
		scr.printMessage("Caught interrupt! waiting for threads and exiting")
                upnpScan.stopIt.set()
                upnpScan.join()
		scr.exitCurse()
	



def guessIP(base, cursesMode,scr):
    # TODO
    # Best guess of IP (10.0.0.0)
    # ipGuess = '10.0.0.1'
    
    if base != '/' or base != '':
        ipGuess = base.split('://')[1]
        if ':' in ipGuess:
        	ipGuess = ipGuess.split(':')[0]
    #     ipGuess = '192.168.1.1'
    else:
        ipGuess = '10.0.0.1'


    (a,b,c,d) = ipGuess.split('.')

    d = int(d)
    originald = d
    d = 2

    if cursesMode:
        scr.printMessage("[-] Guessing internal IP's on block "+ipGuess)
    else:
         print("[-] Guessing internal IP's on block "+ipGuess)
    while d < 255:
        d += 1
        ipGuess = a+'.'+b+'.'+c+'.'+str(d)
        queue.put(ipGuess)






def printhelp():
    print "------------"
    print "Umap v0.8"
    print "By FormateZ"
    print "formatez@toor.do"
    print "------------"
    print "-h: Help"
    print "-b: Bind IP of SOCKS"
    print "-c: Curses mode"
    print "-v: Verbose output"
    print "-p: Port / Port range (Internal Scanning)"
    print "-l: File with list of IP's to be scanned"
    print "-i: Target IP"
    print "-s: SOCKSv4 Proxy mode"
    print "-t: Number of maximum threads"

if __name__ == '__main__':

    socks = 0
    max_threads = 254
    upnp_type = False
    verbose = False
    cursesMode = False
    portLow = 0
    portHigh = 0
    ipArg = ''
    file = ''
    bindIP = ''
    portList = []
    selectedIP = 0
    current_ip = 0
    mapDict = {}
    selectedIPXML = {}
    headers = {
            'USER-AGENT':'Umap/0.8',
            'CONTENT-TYPE':'text/xml; charset="utf-8"'
    }

    try:
        opts, args = getopt.getopt(sys.argv[1:], "hcvst:i:p:l:b:", ["help", "curses", "verbose", "socks", 
								    "threads=", "ip=", "port=", "list=", "bind="])
    except getopt.GetoptError, err:
        print str(err)
        sys.exit(2)


    for o,a in opts:
        if o == "-h":
            printhelp()
            sys.exit(2)
        if o == "-v":
            verbose = 1
	if o == "-c":
	    cursesMode = 1
        if o == "-i":
            if len(a.split('.')) == 4:
            	    ipArg = a
            else:
            	    print "[E] Incorrect IP"
            	    sys.exit()
        if o == "-p":
            if ',' in a:
                for port in a.split(','):
                    if port.isdigit():
                        portList.append(port)
                    else:
                        print "[E] Wrong port number"
                        sys.exit()
            elif '-' in a:
                (portLow, portHigh) = a.split('-')
                if portLow.isdigit() and portHigh.isdigit():
                    portLow = int(portLow)
                    portHigh = int(portHigh)
                    while portLow <= portHigh:
                        portList.append(portLow)
                        portLow += 1
            else:
                if a.isdigit:
                    portList.append(a)
                else:
                    print "[E] Wrong port number"
                    sys.exit()


        if o == "-t":
            if a.isdigit() and int(a) < 512:
                max_threads = a
            else:
                print "Thread limit reached(512)"
                sys.exit()

	if o == "-s":
            socks = 1
	if o == "-b":
            bindIP = a
	    if not a:
		print "Error in bind IP"
		sys.exit()
	if o == "-l":
	    if os.path.exists(a):
                file = a
            else:
                print "File doesn't exist!"
		sys.exit()


    if len(portList) == 0:
        for port in commonPorts:
            portList.append(port)

	
    if socks and (not file and not ipArg):
        print "[E] Must specify IP block list file or IP target"
	sys.exit()

    if cursesMode:
    	    curses.wrapper(main)
    else:
    	    main(None)
