#!/usr/bin/python

import urllib2
import asyncore
import struct
import threading, random, socket
import random
from SOAPpy import *
import xml.dom.minidom as minidom
import sys
import time

# Much thanks to Dan Kaminsky for supplying most of these description XML's
knownLocations = ['/upnp/IGD.xml|80|0', 
                 '/DeviceDescription.xml|80|1',
                 '/allxml/|5431|2', 
                 '/devicedesc.xml|80|3', 
                 '/IGatewayDeviceDescDoc|2869|4', 
                 '/igd.xml|80|5', 
                 '/gatedesc.xml|49152|6', 
                 '/rootDesc.xml|5000|7',
		 '/RootDevice.XML|50718|9',
		 '/UPNP_rootDesc.xml|5819|10',
		 '/rtdevdsc.xml|1900|11',
		 '/gateway.xml|49152|12',
		 '/rootDesc.xml|5555|13',
		 '/upnp/igdrootdesc.xml|80|14',
		 '/x_internetgatewaydevice.xml|80|15',
		 '/desc.xml|80|16',
		 '/DeviceDescrption.xml|9007|17',
		 '/Public_UPNP_gatedesc.xml|80|18',
		 '/gen-desc.xml|4004|19',
		 '/__rootDevice|30888|20',
		 '/gateconnSCPD.xml|80|21',
		 '/RootDevice.xml|8008|22',
		 '/device.xml|51004|23',
		 '/upnp/service/descrip.xml|80|24',
		 '/rootDesc.xml|8200|25',
		 '/DeviceDescription.xml|62802|26',
		 '/rootDesc.xml|65535|27',
		 '/rootDesc.xml|8588|29',
		 '/InternetGatewayDevice.xml|2800|30',
		 '/UPNP_rootDesc.xml|5819|31',
		 '/InternetGatewayDevice.xml|1780|32',
		 '/RootDevice.xml|64340|33',
		 '/igddesc.xml|49000|34',
		 '/RootDevice.xml|34137|35']


class UPNPScan(threading.Thread, asyncore.dispatcher):


    def __init__(self, ip, upnpList, scr, selectedIPXML, serviceList, verbose):

        threading.Thread.__init__ (self)
	asyncore.dispatcher.__init__(self)
        self.stopIt = threading.Event()
        self.ip = ip
        self.knownLocations = knownLocations[:]
	self.upnpList = upnpList
	self.serviceList = serviceList
	self.selectedIPXML = selectedIPXML
	self.verbose = verbose
	if scr == '':
	    self.cursesMode = 0
	else:
	    self.cursesMode = 1
	    self.scr = scr

    def run(self):

        headers = {
               'USER-AGENT':'Umap/0.8',
               'CONTENT-TYPE':'text/xml; charset="utf-8"'
    	}
    	SSDPSearch = ( 'M-SEARCH * HTTP/1.1\r\n' +
    	'Host: 239.255.255.250\r\n' +
    	'ST: upnp:rootdevice\r\n' +
    	'Man: "ssdp:discover"\r\n' +
    	'MX: 3\r\n\r\n')
    	multicastAddr = '239.255.255.250'
    	
    	try:
    		SSDPPort = 1900
    		SSDPSock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
    		
    		SSDPSock.sendto(SSDPSearch, (self.ip, SSDPPort))
    		SSDPSock.settimeout(4)
    		SSDPRx = SSDPSock.recv(4096)
    		SSDPSock.close()

    		for r in SSDPRx.split('\n'):
    			if 'location' in r.lower():
    				SSDPLocation = '/'+'/'.join(':'.join(r.split(':')[1:]).lstrip().split('/')[3:])
    				SSDPLocationPort = r.split(':')[1:][2].split('/')[0]
    				self.knownLocations.insert(0,SSDPLocation+"|"+SSDPLocationPort+"|0")

    		
    	except Exception, err:
    		
    		pass
    	try:
    		SSDPMultiSock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
    		SSDPMultiSock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    		SSDPMultiSock.bind(('', SSDPPort))
    		SSDPMultiSock.setsockopt(socket.IPPROTO_IP, socket.IP_MULTICAST_TTL, 2)
    		req = struct.pack('4sl', socket.inet_aton(multicastAddr), socket.INADDR_ANY)
    		SSDPMultiSock.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, req)
    		SSDPMultiSock.sendto(SSDPSearch, (multicastAddr, SSDPPort))
    		SSDPMultiSock.settimeout(4)
    		SSDPRxm = SSDPMultiSock.recv(4096)
    		SSDPMultiSock.close()
    		
    		for r in SSDPRxm.split('\n'):
    			if 'location' in r.lower():
    				SSDPLocation = '/'+'/'.join(':'.join(r.split(':')[1:]).lstrip().split('/')[3:])
    				SSDPLocationPort = r.split(':')[1:][2].split('/')[0]
    				self.knownLocations.insert(0,SSDPLocation+"|"+SSDPLocationPort+"|0")
	except Exception, err:
		
		pass    		
    	
    	for location in self.knownLocations:
        	data = False

	        (link, port, upnpType) = location.split('|')
	        
	        requestLocation = "http://%s:%s%s" % (self.ip, port, link)
	        try:
		    socket.setdefaulttimeout(5)
          	    request = urllib2.Request(requestLocation, None)
		    response = urllib2.urlopen(request)
		    headers = response.info()
	            data = response.read()
                except Exception, err:
		    if self.cursesMode:
			if self.verbose: self.scr.printMessage("[e] Failed to fetch "+requestLocation)
		    else:
                        if self.verbose: print("[e] Failed to fetch "+requestLocation)
		    continue
	            

 	        if data and data.find('<?xml') != -1:
                    upnp_type = location
		    if self.cursesMode:
		        self.scr.printMessage("[*] Positive match "+requestLocation)
		    else:
                        print("[*] Positive match "+requestLocation)
		    self.soapInfo = self.getInfo(location, self.ip, 0)
		    if not self.soapInfo:
		        continue
		    else:
		        try:
		            
			    self.upnpList.append(str(self.ip)+"|"+str(self.soapInfo[2])+"|"+str(port)+"|"+str(location)+"|"+str(self.soapInfo[1])+"|"+str(self.soapInfo[0])+"|"+str(self.soapInfo[6])+"|"+str(self.soapInfo[3]))
			    break
		        except Exception, err:
		            print(err)


	
    def getInfo(self, location, ip, paint):

	    st = time.time()
	    (link, port, upnpType) = location.split('|')
            requestLocation = "http://%s:%s%s" % (ip, port, link)

	    on = 0
	    out = {}
	    newXml = ''
	    location = ''
	    data = ''
	    base = ''
	    tags = ['URLBase', 'friendlyName', 'modelDescription', 'modelName', 'modelNumber', 'serialNumber', 'UDN']
	    try:
                request = urllib2.Request(requestLocation, None)
                response = urllib2.urlopen(request)
                headers = response.info()
                xmlData = response.read()
            except Exception, err:
                return False

	    ed = time.time()
	    
	    for line in xmlData.split('\n'):
#	    	    newXml += line+'\n'
		if '<?xml ' in line or on == 1:
			on = 1
			newXml += line+'\n'
		if '</root' in line:
			on = 0
			break
	    try:
	    	if len(newXml) > 0:
	    		xmlRoot = minidom.parseString(newXml)
	    	else:
	    		return False
	    except Exception, err:
		if self.cursesMode:
			f = open('/tmp/tester.log', 'a')
			f.write(xmlData)
		        self.scr.printMessage("[E] Error parsing XML"+str(len(newXml)))		        
		else:
			print("[E] Error parsing XML")
		return False


	    
	    for service in xmlRoot.getElementsByTagName('service'):
	        try:
	            serviceType = service.getElementsByTagName('serviceType')[0].childNodes[0].data
	            wanXml = service.getElementsByTagName('SCPDURL')[0].childNodes[0].data
	            controlURL = service.getElementsByTagName('controlURL')[0].childNodes[0].data
	        except Exception, err:
		    if self.cursesMode:
	                self.scr.printMessage("[E] Error fetching main tags")
		    else:
		        print("[E] Error fetching main tags") 
	            return False
	        if self.serviceList.has_key(ip):
	        	self.serviceList[ip] += serviceType+"|"+wanXml+"|"+controlURL+","
	        else:
	        	self.serviceList[ip] = serviceType+"|"+wanXml+"|"+controlURL+","
	        
	        if 'WANPPP' in serviceType or 'WANIP' in serviceType:
	            for tag in tags:
	                try:
	                    out[tag] = xmlRoot.getElementsByTagName(tag)[0].childNodes[0].data
			    if paint == 1: self.scr.selectedIPXML[tag] = xmlRoot.getElementsByTagName(tag)[0].childNodes[0].data
	                except:
	                    pass
		    timing = (ed-st)*1000.0
	            if 'URLBase' in out:
	                base = out['URLBase']
		    else:
			base = ''
		    
		    return (serviceType, wanXml, controlURL, base, port, link, timing)
